# -*- coding: utf-8 -*-

"""
whatsappcloudapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from whatsappcloudapi.api_helper import APIHelper
from whatsappcloudapi.configuration import Server
from whatsappcloudapi.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from whatsappcloudapi.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from whatsappcloudapi.models.get_phone_number_by_id_response import GetPhoneNumberByIDResponse
from whatsappcloudapi.models.success_response import SuccessResponse


class PhoneNumbersController(BaseController):

    """A Controller to access Endpoints in the whatsappcloudapi API."""
    def __init__(self, config):
        super(PhoneNumbersController, self).__init__(config)

    def get_phone_number_by_id(self,
                               phone_number_id):
        """Does a GET request to /{Phone-Number-ID}.

        When you query all the phone numbers for a WhatsApp Business Account,
        each phone number has an id. You can directly query for a phone number
        using this id.

        Args:
            phone_number_id (string): TODO: type description here.

        Returns:
            GetPhoneNumberByIDResponse: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/{Phone-Number-ID}')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('Phone-Number-ID')
                            .value(phone_number_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(GetPhoneNumberByIDResponse.from_dictionary)
        ).execute()

    def request_verification_code(self,
                                  phone_number_id,
                                  code_method,
                                  locale):
        """Does a POST request to /{Phone-Number-ID}/request_code.

        Used to request a code to verify a phone number's ownership. You need
        to verify the phone number you want to use to send messages to your
        customers. Phone numbers must be verified through SMS/voice call. The
        verification process can be done through the Graph API calls specified
        below.

        Args:
            phone_number_id (string): TODO: type description here.
            code_method (RequestVerificationCodeMethodEnum): Chosen method for
                verification.
            locale (string): Your locale. For example: "en_US".

        Returns:
            SuccessResponse: Response from the API.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/{Phone-Number-ID}/request_code')
            .http_method(HttpMethodEnum.POST)
            .template_param(Parameter()
                            .key('Phone-Number-ID')
                            .value(phone_number_id)
                            .should_encode(True))
            .form_param(Parameter()
                        .key('code_method')
                        .value(code_method))
            .form_param(Parameter()
                        .key('locale')
                        .value(locale))
            .header_param(Parameter()
                          .key('content-type')
                          .value('application/x-www-form-urlencoded'))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(SuccessResponse.from_dictionary)
        ).execute()

    def verify_code(self,
                    phone_number_id,
                    code):
        """Does a POST request to /{Phone-Number-ID}/verify_code.

        Used to verify a phone number's ownership. After you have received a
        SMS or Voice request code for verification, you need to verify the
        code that was sent to you.

        Args:
            phone_number_id (string): TODO: type description here.
            code (string): The code you received after calling
                FROM_PHONE_NUMBER_ID/request_code.

        Returns:
            SuccessResponse: Response from the API.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/{Phone-Number-ID}/verify_code')
            .http_method(HttpMethodEnum.POST)
            .template_param(Parameter()
                            .key('Phone-Number-ID')
                            .value(phone_number_id)
                            .should_encode(True))
            .form_param(Parameter()
                        .key('code')
                        .value(code))
            .header_param(Parameter()
                          .key('content-type')
                          .value('application/x-www-form-urlencoded'))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(SuccessResponse.from_dictionary)
        ).execute()
